<?php if(!defined('PmWiki')) exit();

 /**
 *  Copyright 2011 Carlos A. Bonamigo <cabsec.pmwiki@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

/// JSCOMPRESS - Compresses javascript files

/// INCLUDES

// we use jsmin from google's minify
include_once('cookbook/jscompress/jsmin.php');

/// VARIABLES

$RecipeInfo['jscompress']['version'] = '20110416';

$HandleActions['jscompress'] = 'HandleJsCompress';
$HandleAuth['jscompress'] = 'admin';

// complete or relative path to files
// don't forget to check file permissions
// I decided not to touch it from here
// it also accepts anything that
// can be replaced by FmtPageName
SDV($JsCompressFiles , array(
  './pub/js/jquery.js' => './pub/js/jquery.cmp.js',
));

// message to show
// as part of the page
// when csscompress is called
SDV($JsCompressMessage, '
(:title Action -> Js Compress :)
(:div style="text-align:center":)
You have to fill the array called $JsCompressFiles so this action can work.[[<<]]
Click the link bellow to see some action![[<<]]
[[{$ScriptUrl}?n={$FullName}&action=jscompress| JS COMPRESS]] [[<<]]
[[<<]]
You can change this message editing the var called $JsCompressMessage[[<<]]
(:divend:)
----[[<<]]'
);


/// FUNCTIONS

function JsCompress($j){

   $j = new JSMin($j);
   return $j->min();

}

/// HANDLER

function HandleJsCompress($pagename,$auth='admin'){
  global $JsCompressOverWrite,$JsCompressFiles,
         $JsCompressMessage,$PageStartFmt,$PageEndFmt;

  $page = RetrieveAuthPage($pagename, $auth, true, READPAGE_CURRENT);
  if (!$page) Abort("Insufficient permissions for JsCompress");

  $msg = MarkupToHTML($pagename,$JsCompressMessage);
  foreach($JsCompressFiles as $k => $v){
    $infile = FmtPageName($k, $pagename);
    $outfile = FmtPageName($v, $pagename);
    if(!file_exists($infile)){
      $msg .= "$[Js infile does not exist] -> ".$infile."<br/>\n";
    }else{
      if($writeperm == false)
        $msg .= "$[Js outfile couldn't be created] -> ".$outfile."<br/>\n";
      if(!($jscontents = file_get_contents($infile)))
        $msg .= "$[Couldn't open js infile for compression] -> ".$infile."<br/>\n";
      if(!($jscompressed = JsCompress($jscontents))) 
        $msg .= "$[Couldn't compress the opened js infile] -> ".$infile."<br/>\n";
      if($jscompressed != ''){
        if(!file_put_contents($outfile,$jscompressed))
          $msg .= "$[Couldn't open outfile] -> ".$outfile.".\n";
        else $msg .= $infile." - $[File compressed and saved in] -> ".$outfile."<br/>\n";
      }
    }
  }

  $PageJsCompressFmt = "<div>".FmtPageName($msg, $pagename)."</div>";
  SDV($HandleJsCompressFmt, array(&$PageStartFmt, &$PageJsCompressFmt, &$PageEndFmt));
  PrintFmt($pagename, $HandleJsCompressFmt);
}
